//	Forward declarations.
class CNstestDoc;

//	If compiling in 32 bit mode, BOOLs change size.
typedef short TwoByteBool;

class CDDEConversation : public CObject	{
public:
	virtual void Serialize(CArchive& ar);
	DECLARE_SERIAL( CDDEConversation )
	
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif // _DEBUG

	CDDEConversation(HCONV hConv);
	~CDDEConversation();
	CNstestDoc *GetDocument();
	
	static CDDEConversation *ResolveConversation(HCONV hConv);
	
	void DoDisconnect();
	
	HDDEDATA ServerPoke(HSZ hszTopic, HSZ hszItem, HDDEDATA hDataPoke);
	HDDEDATA ServerRequest(HSZ hszTopic, HSZ hszItem);	
	HDDEDATA ClientRequest(HSZ hszItem);
	HDDEDATA ClientPoke(HSZ hszItem);
	
protected:
	//	Conversation that we're handling.
	HCONV m_hConv;
	
	//	List of all conversations going on (for informational lookup), and instance
	//		index into that list.
	static CObList m_colConversations;
	POSITION m_rIndex;
	
	CDDEConversation();
	
	//	Useful routines for client/server interaction.
	void ClientPassed(HSZ hszItem, const char *pFormat, ...);
	HDDEDATA ServerReturns(const char *pFormat, ...);
	
	//	Server Pokes
	HDDEDATA WWW_EndProgress(HSZ hszItem);
	HDDEDATA WWW_SetProgressRange(HSZ hszItem);
	HDDEDATA WWW_URLEcho(HSZ hszItem);
	HDDEDATA WWW_ViewDocFile(HSZ hszItem);
	HDDEDATA WWW_WindowChange(HSZ hszItem);
	
	//	Server Requests
	HDDEDATA WWW_Alert(HSZ hszItem);
	HDDEDATA WWW_BeginProgress(HSZ hszItem);
	HDDEDATA WWW_MakingProgress(HSZ hszItem);
	HDDEDATA WWW_OpenURL(HSZ hszItem);
	HDDEDATA WWW_QueryViewer(HSZ hszItem);
	
private:
	void CommonConstruction();
};

#define DDETIMEOUT 60000UL	//	One minute in milliseconds